// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_LF_MOM_BACKEND/grmi"
	meta "LAPP_LF_MOM_BACKEND/meta/api"
	model "LAPP_LF_MOM_BACKEND/models/api"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : ACCUNITSTATUSDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : ACCUNITSTATUS的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-05-25 15:07:15
 *
 ******************************************************************************/
type ACCUNITSTATUSDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewACCUNITSTATUSDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个ACCUNITSTATUSDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *

 * @Return Value             : ACCUNITSTATUSDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-05-25 15:07:15
 *
 ******************************************************************************/
func NewACCUNITSTATUSDAOImplement(session *xorm.Session, userid string) *ACCUNITSTATUSDAOImplement {
	return &ACCUNITSTATUSDAOImplement{session, &meta.ACCUNITSTATUS, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCUNITSTATUSDAO.InsertOne
 *
 ******************************************************************************/
func (impl *ACCUNITSTATUSDAOImplement) InsertOne(entity *model.ACCUNITSTATUS) error {

	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCUNITSTATUSDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *ACCUNITSTATUSDAOImplement) DeleteOne(uNITSN string, lINE string) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{uNITSN, lINE}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCUNITSTATUSDAO.SelectOne
 *
 ******************************************************************************/
func (impl *ACCUNITSTATUSDAOImplement) SelectOne(uNITSN string, lINE string) (*model.ACCUNITSTATUS, error) {
	var data model.ACCUNITSTATUS
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{uNITSN, lINE}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCUNITSTATUSDAO.SelectInfo
 *
 ******************************************************************************/
func (impl *ACCUNITSTATUSDAOImplement) SelectInfo(uNITSN string) (*model.ACCUNITSTATUS, error) {
	var data model.ACCUNITSTATUS
	ok, err := impl.session.Table(impl.meta.TableName).Where("UNITSN = ?",uNITSN).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}


/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCUNITSTATUSDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *ACCUNITSTATUSDAOImplement) UpdateOne(entity *model.ACCUNITSTATUS) error {

	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCUNITSTATUSDAO.Insert
 *
 ******************************************************************************/
func (impl *ACCUNITSTATUSDAOImplement) Insert(entities *[]model.ACCUNITSTATUS) error {
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCUNITSTATUSDAO.Delete
 *
 ******************************************************************************/
func (impl *ACCUNITSTATUSDAOImplement) Delete(entities *[]model.ACCUNITSTATUS) error {
	for _, entity := range *entities {

		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCUNITSTATUSDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *ACCUNITSTATUSDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{}
	where := ""

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCUNITSTATUSDAO.Select
 *
 ******************************************************************************/
func (impl *ACCUNITSTATUSDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.ACCUNITSTATUS, error) {

	parameters := []interface{}{}
	where := ""

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.ACCUNITSTATUS, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCUNITSTATUSDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *ACCUNITSTATUSDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{}
	where := ""

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by "
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.ACCUNITSTATUS, 0, 10)
	if where != "" {
		where = " where " + where
	}
	err = impl.session.Table(impl.meta.TableName).SQL("select * from "+impl.meta.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCUNITSTATUSDAO.Update
 *
 ******************************************************************************/
func (impl *ACCUNITSTATUSDAOImplement) Update(entities *[]model.ACCUNITSTATUS) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]

		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCUNITSTATUSDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *ACCUNITSTATUSDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.ACCUNITSTATUS, columns ...string) error {

	parameters := []interface{}{}
	where := ""

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}
	_, err := impl.session.Table(impl.meta.TableName).Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}
